<script setup lang="ts">
import { useProductStore } from '@/stores/product'
import Swal from 'sweetalert2';
import { computed, onMounted, ref, watchEffect } from 'vue'
import type { VForm } from 'vuetify/components'
const productStore = useProductStore()
const form = ref(false)
const loading = ref(false)
const types = ref('')
const selectedTypes = ref(['H', 'C', 'F'])
const selectedSweets = ref(['100%','50%','25%'])
const refform = ref<VForm | null>(null)

const watchSelectedTypes = () => {
  // เมื่อมีการเลือกหรือยกเลิกค่าใน selectedTypes
  // ค่าใน gType จะถูกอัปเดตเป็น string ที่รวมทุกค่าที่ถูกเลือก
  types.value = selectedTypes.value.join('')
}
watchEffect(watchSelectedTypes)
function setType() {
  selectedTypes.value = ['H', 'C', 'F']
}


async function save() {
  let { valid } = await refform.value!.validate()
  if (!valid) return
  console.log(productStore.editedProduct)
  productStore.editedProduct.type = types.value
  productStore.save()
  setType()
  Swal.fire({
  icon: "success",
  title: "Your work has been saved",
  showConfirmButton: false,
  timer: 1500
});
}
</script>
<template>
  <v-row justify="center">
    <v-dialog v-model="productStore.dialog" persistent width="500">
      <v-card>
        <v-card-title>
          <span class="text-h5">Add Stock Product</span>
        </v-card-title>
        <v-card-text>
          <v-form ref="refform" v-model="form">
            <v-container>
              <v-row>
                <v-col cols="12" sm="12" md="12" style="padding: 0">
                  <v-text-field
                    v-model="productStore.editedProduct.name"
                    :readonly="loading"
                    :rules="[(v) => !!v || 'Field is required']"
                    class="mb-2"
                    clearable
                    label="Product Name"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="12" md="12" style="padding: 0">
                  <v-combobox
                    label="Category"
                    :items="['Drink', 'Bakery', 'Food']"
                    v-model="productStore.editedProduct.category"
                  ></v-combobox>
                </v-col>
                <v-col
                  cols="12"
                  sm="12"
                  md="12"
                  v-if="productStore.editedProduct.category == 'Drink'"
                  style="padding: 0"
                >
                  <v-combobox
                    label="Size"
                    :items="['H', 'C', 'F']"
                    v-model="selectedTypes"
                    multiple
                    :rules="[(v) => !!v.length || 'Select at least one option']"
                  ></v-combobox>
                </v-col>
                <v-col cols="12" sm="12" :md="12" style="padding: 0">
                  <v-text-field
                    v-model="productStore.editedProduct.price"
                    :readonly="loading"
                    :rules="[(v) => !!v || 'Field is required', (v) => v > 0 || 'น้อยไปป่าว']"
                    class="mb-2"
                    clearable
                    label="Price"
                    @keyup.enter="save()"
                    inputmode="numeric"
                    pattern="[0-9]*"
                    type="number"
                  ></v-text-field>
                </v-col>
              </v-row>
              <v-col cols="12" sm="6" md="4">
                <v-file-input
                  v-model="productStore.editedProduct.files"
                  :rules="[
                    (value) => {
                      return (
                        !value ||
                        !value.length ||
                        value[0].size < 2000000 ||
                        'Image size should be less than 2 MB!'
                      )
                    }
                  ]"
                  accept="image/png, image/jpeg"
                  placeholder="Pick an image"
                  prepend-icon="mdi-camera"
                  label="Image"
                ></v-file-input>
              </v-col>
              <v-col cols="12" sm="6" md="4">
                <v-img
                  :src="'http://localhost:3000/images/products/' + productStore.editedProduct.image"
                  width="200"
                ></v-img>
              </v-col>
            </v-container>
          </v-form>
          <small>*indicates required field</small>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn
            color="blue-darken-1"
            variant="text"
            @click="productStore.closeDialog(), setType()"
          >
            Close
          </v-btn>
          <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>




        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-row>
</template>
